# BM Class Reference
[Core BDM classes]

Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities. More...

`#include <libBM.h>`

Inheritance diagram for BM:

[legend]
Collaboration diagram for BM:

[legend]

List of all members.

## Public Member Functions
| BM (const RV &rv0, double ll0=0, bool evalll0=true)
| Default constructor.
| BM (const BM &B)
| Copy constructor.
virtual void | bayes (const vec &dt)=0
| Incremental Bayes rule.
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual const epdf & | _epdf () const =0
| Returns a reference to the epdf representing posterior density on parameters.
virtual const epdf * | _e () const =0
| Returns a pointer to the epdf representing posterior density on parameters. Use with care!
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | predictor (const RV &rv) const
| Constructs a predictive density (marginal density on data).
virtual | ~BM ()
| Destructor for future use;.
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
virtual BM * | _copy_ (bool changerv=false)
## Protected Attributes
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Detailed Description

Bayesian Model of the world, i.e. all uncertainty is modeled by probabilities.

## Member Function Documentation

virtual void BM::bayes | ( | const vec & | dt | ) | `[pure virtual]`

Incremental Bayes rule.

Parameters:

  | dt | vector of input data

Implemented in ARX, Kalman< sq_T >, KalmanCh, EKFfull, EKF< sq_T >, EKFCh, PF, MPF< BM_T >, MixEF, BMEF, multiBM, EKFfixed, Kalman< ldmat >, Kalman< chmat >, and Kalman< fsqmat >.

Referenced by bayesB().

virtual double BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in ARX, MixEF, and multiBM.

Referenced by logpred_m().

virtual BM* BM::_copy_ | ( | bool | changerv = `false` | ) | `[inline, virtual]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*); return Tmp; }

Reimplemented in ARX, and BMEF.

The documentation for this class was generated from the following files:

- work/git/mixpp/bdm/stat/libBM.h
- work/git/mixpp/bdm/stat/libBM.cpp